package com.sf.web.dms.faultlist.control;

package ..deTemp.1731583096408;

import com.sf.web.dms.abnormal.bean.RiskQueryParaVO;
import com.sf.web.dms.faultlist.entity.DaFaultOpen;
import com.sf.web.dms.faultlist.entity.DaFaultOpenPK;
import com.sf.web.dms.faultlist.service.MyDaFaultGroundFeederService;
import com.smartframework.core.annotation.SmartComment;
import com.smartframework.core.dao.page.PagingBean;
import com.smartframework.core.i18n.I18n;
import com.smartframework.core.smart.SmartView;
import com.smartframework.web.core.control.BasicControl;
import com.smartframework.web.core.queryfilter.QueryFilter;
import com.smartframework.web.core.util.ParameterUtils;
import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@SmartComment("DaFaultOpen实例增删改查接口层")
public class MyDaFaultGroundFeederControl extends BasicControl {
  private MyDaFaultGroundFeederService myDaFaultGroundFeederService;
  
  public MyDaFaultGroundFeederService getMyDaFaultGroundFeederService() {
    return this.myDaFaultGroundFeederService;
  }
  
  public void setMyDaFaultGroundFeederService(MyDaFaultGroundFeederService myDaFaultGroundFeederService) {
    this.myDaFaultGroundFeederService = myDaFaultGroundFeederService;
  }
  
  @SmartComment("保存DaFaultOpen实例")
  public SmartView save(DaFaultOpen daFaultOpen) {
    return dbAccess(this.myDaFaultGroundFeederService.save(daFaultOpen));
  }
  
  @SmartComment("按ID列表删除DaFaultOpen对象")
  public SmartView delete(List<DaFaultOpenPK> ids) {
    return dbAccess(this.myDaFaultGroundFeederService.delete(ids, false));
  }
  
  @SmartComment("按ID列表彻底删除DaFaultOpen对象")
  public SmartView deletePermanently(List<DaFaultOpenPK> ids) {
    return dbAccess(this.myDaFaultGroundFeederService.delete(ids, false));
  }
  
  @SmartComment("按ID获取单个DaFaultOpen实例")
  public SmartView loadOne(DaFaultOpenPK id) {
    return SmartView.SUCCESS(this.myDaFaultGroundFeederService.get(id));
  }
  
  @SmartComment("获取DaFaultOpen实例的分页查询结果")
  public SmartView list(String name, Integer pageSize, Integer pageIndex, String sortField, String sortOrder, String columns, String method) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(name))
      queryFilter.addStringFieldLikeCondition("e.name", name); 
    if (pageSize == null || pageIndex == null)
      return SmartView.ERROR(I18n.message("error.parameter.empty", "分页参数{0}不能为空", new Object[] { "pageIndex,pageSize" })); 
    queryFilter.addSorted(sortField, sortOrder);
    queryFilter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.myDaFaultGroundFeederService.queryRecords(queryFilter);
    return pageView(page);
  }
  
  public SmartView loadFeederListDesc(RiskQueryParaVO paraVO) {
    Map<Long, String> ret = this.myDaFaultGroundFeederService.queryFeederRecords(paraVO);
    return SmartView.SUCCESS(ret);
  }
  
  public SmartView loadDaFaultInfoByQueryIdList(Long startTime, Long endTime, List<Long> stationIdList, List<Long> feederIdList, List<Long> faultTypeList, Integer pageSize, Integer pageIndex, String columns, String method) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(startTime) && !ParameterUtils.isEmptyOrNull(endTime)) {
      queryFilter.addDateFieldBetweenCondition("e.fault_time", new Date(startTime.longValue()), new Date(endTime.longValue()));
    } else {
      return SmartView.ERROR(I18n.message("error.parametertime.empty", "起始时间或者结束时间不能为空", new Object[] { "startTime,endTime" }));
    } 
    if (!ParameterUtils.isEmptyOrNull(stationIdList))
      queryFilter.addNumberFieldInCondition("e.station_id", stationIdList); 
    if (!ParameterUtils.isEmptyOrNull(feederIdList))
      queryFilter.addNumberFieldInCondition("e.feeder_id", feederIdList); 
    List<Long> faultTypeInfoList = new ArrayList<>();
    faultTypeInfoList.add(Long.valueOf(4L));
    faultTypeInfoList.add(Long.valueOf(6L));
    faultTypeInfoList.add(Long.valueOf(7L));
    queryFilter.addNumberFieldInConditionAsOrLink("e.fault_mode", faultTypeInfoList);
    if (pageSize == null || pageIndex == null)
      return SmartView.ERROR(I18n.message("error.parameter.empty", "分页参数{0}不能为空", new Object[] { "pageIndex,pageSize" })); 
    queryFilter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.myDaFaultGroundFeederService.queryDaFaultRecords(queryFilter);
    List<Map<String, Object>> data = page.getData();
    List<Map<String, Object>> newtypedata = new ArrayList<>();
    if (faultTypeList.size() != 0) {
      for (int k = 0; k < data.size(); k++) {
        Map<String, Object> tgAveObj = data.get(k);
        Object objtype = tgAveObj.get("faultType");
        String returenname = loadDafaulttype(objtype, faultTypeList);
        if (returenname == "1")
          newtypedata.add(tgAveObj); 
      } 
    } else {
      for (int k = 0; k < data.size(); k++) {
        Map<String, Object> tgAveObj = data.get(k);
        newtypedata.add(tgAveObj);
      } 
    } 
    List<Object> daFaultIdvector = new ArrayList();
    List<Map<String, Object>> newData = new ArrayList<>();
    for (int i = 0; i < newtypedata.size(); i++) {
      Map<String, Object> tgAveObj = newtypedata.get(i);
      Object devId = tgAveObj.get("id");
      if (!daFaultIdvector.contains(devId)) {
        daFaultIdvector.add(devId);
        Map<String, Object> faultobj = new HashMap<>();
        faultobj.put("id", tgAveObj.get("id"));
        faultobj.put("faultTime", tgAveObj.get("faultTime"));
        faultobj.put("feederName", tgAveObj.get("feederName"));
        newData.add(faultobj);
      } 
    } 
    int totalNum = page.getTotalItems();
    int totalNumAll = newData.size();
    page.setTotalItems(totalNumAll);
    page.setData(newData);
    return pageView(page);
  }
  
  @SmartComment("Excel文件导入")
  public SmartView importFile(File file) {
    return SmartView.SUCCESS();
  }
  
  public String loadDafaulttype(Object faulttype, List<Long> faultTypeList) {
    StringBuilder da_faulttype_desc = new StringBuilder("");
    String stringType = faulttype.toString();
    int typeNum = Integer.parseInt(stringType);
    String tagname = "0";
    if (typeNum == 0) {
      Object valuenormal = Integer.valueOf(-1);
      for (int mm = 0; mm < faultTypeList.size(); mm++) {
        Long typetag = faultTypeList.get(mm);
        if (typetag.longValue() == -1L) {
          tagname = "1";
          break;
        } 
      } 
    } else {
      for (int i = 0; i < faultTypeList.size(); i++) {
        Long typetag = faultTypeList.get(i);
        if (typetag.longValue() != -1L) {
          int b1 = typeNum & 1 << (int)typetag.longValue();
          if (b1 > 0) {
            tagname = "1";
            break;
          } 
        } 
      } 
    } 
    return tagname;
  }
}
